/**
 * Blockly Apps: Turtle Graphics Blocks
 *
 * Copyright 2012 Google Inc.
 * https://blockly.googlecode.com/
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview Blocks for Blockly's Turtle Graphics application.
 * @author ivana@ivana.it (Ivana Sacchi)
 */
'use strict';

// Extensions to Blockly's language and JavaScript generator.
 
       
 Blockly.Blocks['Risultato'] = {
  init: function() {
      this.setColour(120);
    this.appendDummyInput()
        .appendField(StringaRisposta);
     this.setOutput(true);
    },
  customUpdate: function() {
 	   if (NumeroRisultato==NumeroRisultato.toFixed(0)){
	         this.setFieldValue(StringaRisposta.replace('...', NumeroRisultato.toFixed(0)));
	 }else{this.setFieldValue(StringaRisposta.replace('...', NumeroRisultato.toFixed(2)));}
  }
};

 Blockly.JavaScript['Risultato'] = function() {
     return   (  "") 
 };
 
Blockly.Blocks['StampaRisultato'] = {
     init: function() {
        this.setColour(160);
        this.appendDummyInput()
      	.appendField ('La variabile')
        this.appendValueInput('VALUE')
        .setCheck('Number') 
       this.setInputsInline(true);
        this.appendValueInput('RISULTATO')
        .setCheck('Number') 
       this.setTooltip("Restituisce il valore di una variabile");
    }
};
  
  
 Blockly.JavaScript['StampaRisultato'] = function(a) {
     return (Blockly.JavaScript.valueToCode(a, "VALUE", Blockly.JavaScript.ORDER_NONE) || "") 
 };


Blockly.Blocks['ImpostaVariabile'] =  {
    init: function() {
		  var Elementi =
         [ ['AC', 'AC'], ['BH', 'BH'] ,['perimetro', 'perimetro'],['area', 'area']];
           this.setColour(330);
  	     this.appendDummyInput()
       	.appendField ('Imposta')
        .appendField(new Blockly.FieldDropdown(Elementi), 'VAR')
           this.appendValueInput('VALUE')
        .setCheck('Number');
 	    this.setInputsInline(true);
		this.setPreviousStatement(true);
		this.setNextStatement(true);
        this.setTooltip('Imposta una variabile');
        } 
 };

 Blockly.JavaScript['ImpostaVariabile']  = function(a) {
     var b = Blockly.JavaScript.valueToCode(a, "VALUE", Blockly.JavaScript.ORDER_ASSIGNMENT) || "0";
     return Blockly.JavaScript.variableDB_.getName(a.getFieldValue("VAR"), Blockly.Variables.NAME_TYPE) + " = " + b + ";\n"
 };

 Blockly.Blocks['OttieniVariabile']  = {
    init: function() {
   	  var Elementi =
         [ ['AC', 'AC'], ['BH', 'BH'] ,['perimetro', 'perimetro'],['area', 'area']];
        this.setColour(330);
        this.appendDummyInput()
  	    .appendField(new Blockly.FieldDropdown(Elementi), 'VAR')
        this.setOutput(true);
        this.setTooltip('Ottiene il valore delle variabili impostate');
     },
 };

 Blockly.JavaScript['OttieniVariabile'] = function(a) {
     return [Blockly.JavaScript.variableDB_.getName(a.getFieldValue("VAR"), Blockly.Variables.NAME_TYPE), Blockly.JavaScript.ORDER_ATOMIC]
 };


Blockly.Blocks['RadiceQuadrata']  = {
    init: function() {
        var a = [
            [Blockly.Msg.MATH_SINGLE_OP_ROOT, "ROOT"] 
        ];
         this.setColour(230);
        this.setOutput(true, "Number");
        this.interpolateMsg("%1 %2", ["OP", new Blockly.FieldDropdown(a)], ["NUM", "Number", Blockly.ALIGN_RIGHT], Blockly.ALIGN_RIGHT);
        var b = this;
       this.setTooltip('Calcola la radice quadrata');
    }
};

 Blockly.JavaScript['RadiceQuadrata'] = function(a) {
 
     var b = a.getFieldValue("OP"), c;
     a = "SIN" == b || "COS" == b || "TAN" == b ? Blockly.JavaScript.valueToCode(a, "NUM", Blockly.JavaScript.ORDER_DIVISION) || "0" : Blockly.JavaScript.valueToCode(a, "NUM", Blockly.JavaScript.ORDER_NONE) || "0";
     	             c = "Math.sqrt(" + a + ")";
        if (c) return [c, Blockly.JavaScript.ORDER_FUNCTION_CALL];
   
 };